diff -urN microwindows-0.91/src/drivers/fblin32alpha.c microwindows-0.91.g100/src/drivers/fblin32alpha.c
--- microwindows-0.91/src/drivers/fblin32alpha.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/drivers/fblin32alpha.c	2007-06-07 23:22:14.000000000 +0200
@@ -23,6 +23,13 @@
 typedef unsigned long MW_U32;
 typedef long MW_S32;
 
+/*REM*/extern unsigned char* gr_alpha;  /* current alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_x;         /* current x position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_y;         /* current y position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_width;     /* current width of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_height;    /* current height of alpha channel*/
+/*REM*/extern MWCLIPMAP *clipmap ;
+
 /* It's a lot easier to treat the buffer as an array of bytes when
  * alpha blending, and an array of MW_U32 otherwise.  However,
  * without some care, that would not be portable due to endian
@@ -95,7 +102,23 @@
 	assert(addr != 0);
 	assert(x >= 0 && x < psd->xres);
 	assert(y >= 0 && y < psd->yres);
-
+#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	   MWCOORD crcx=x-clipmap->clipregion->left;
+	/*REM*/	   MWCOORD crcy=y-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right - clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/    if(!(*crc)) return;
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=x-gr_alpha_x;
+	/*REM*/MWCOORD rely=y-gr_alpha_y;
+	/*REM*/if(gr_alpha && (relx>=0)&&(relx<gr_alpha_width)&&(rely>=0)&&(rely<gr_alpha_height))
+	/*REM*/  {if(!gr_alpha[relx+(rely*gr_alpha_width)]) return;}
+#endif
 	addr += x + y * psd->linelen;
 
 	DRAWON;
@@ -185,16 +208,58 @@
 
 	addr += x1 + y * psd->linelen;
 
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	    MWCOORD crcx=x1-clipmap->clipregion->left;
+	/*REM*/	    MWCOORD crcy=y-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+	
+	/*REM*/ MWCOORD relx1=x1-gr_alpha_x;
+	/*REM*/ MWCOORD relx2=x2-gr_alpha_x;
+	/*REM*/ MWCOORD rely =y-gr_alpha_y;
+	/*REM*/ unsigned char* alpha=NULL;
+  	/*REM*/  if(gr_alpha && (relx1>=0) && (relx2<gr_alpha_width) && (rely>=0) && (rely<gr_alpha_height) &&
+	/*REM*/     ((x2-x1)<=gr_alpha_width))
+	/*REM*/       alpha=&gr_alpha[relx1+(rely*gr_alpha_width)];
+/*REM*/#endif
+
 	DRAWON;
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/if (gr_mode == MWMODE_COPY) {
+ 	/*REM*/         while (x1++ <= x2){
+	/*REM*/	       if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) *addr = c;}
+	/*REM*/	       if(crc)crc++;
+	/*REM*/	       if(alpha)alpha++;
+	/*REM*/	       addr++;
+	/*REM*/	 }
+	/*REM*/} else if (gr_mode <= MWMODE_SIMPLE_MAX) {
+	/*REM*/	while (x1++ <= x2) {
+	/*REM*/	        if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) applyOp(gr_mode, c, addr, ADDR32);}
+	/*REM*/		if(crc)crc++;
+	/*REM*/	        if(alpha)alpha++;
+	/*REM*/		++addr;
+	/*REM*/	}
+
+/*REM*/#else
 	if (gr_mode == MWMODE_COPY) {
 		/* FIXME: memsetl(dst, c, x2-x1+1) */
 		while (x1++ <= x2)
 			*addr++ = c;
 	} else if (gr_mode <= MWMODE_SIMPLE_MAX) {
 		while (x1++ <= x2) {
-			applyOp(gr_mode, c, addr, ADDR32);
+		        applyOp(gr_mode, c, addr, ADDR32);
 			++addr;
 		}
+/*REM*/#endif
+
+	//*REM*/Dont know how to handle this for trans color
 	} else {
 		MW_S32 psr, psg, psb;
 		MW_S32 psa, psa_inv;
@@ -309,8 +374,46 @@
 	assert(y2 >= 0 && y2 < psd->yres);
 	assert(y2 >= y1);
 
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	    MWCOORD crcx=x-clipmap->clipregion->left;
+	/*REM*/	    MWCOORD crcy=y1-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=x-gr_alpha_x;
+	/*REM*/MWCOORD rely1=y1-gr_alpha_y;
+	/*REM*/MWCOORD rely2=y2-gr_alpha_y;
+	/*REM*/unsigned char* alpha=NULL;
+	/*REM*/if(gr_alpha&& (relx>=0)&&(relx<gr_alpha_width)&&(rely1>=0)&&(rely1+rely2<=gr_alpha_height))
+	/*REM*/     alpha=&gr_alpha[relx+(rely1*gr_alpha_width)];
+/*REM*/#endif
+
 	DRAWON;
 	addr += x + y1 * linelen;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/if (gr_mode == MWMODE_COPY) {
+	/*REM*/	while (y1++ <= y2) {
+	/*REM*/	        if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) *addr = c;}
+	/*REM*/	        if(crc)crc+=clinelen;
+	/*REM*/	        if(alpha)alpha+=gr_alpha_width;
+	/*REM*/		addr += linelen;
+	/*REM*/	}
+	/*REM*/} else if (gr_mode <= MWMODE_SIMPLE_MAX) {
+	/*REM*/	while (y1++ <= y2) {
+	/*REM*/         if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha))applyOp(gr_mode, c, addr, ADDR32);}
+	/*REM*/         if(crc)crc+=clinelen;
+	/*REM*/	        if(alpha)alpha+=gr_alpha_width;
+	/*REM*/		addr += linelen;
+	/*REM*/	}
+/*REM*/#else
 	if (gr_mode == MWMODE_COPY) {
 		while (y1++ <= y2) {
 			*addr = c;
@@ -321,7 +424,9 @@
 			applyOp(gr_mode, c, addr, ADDR32);
 			addr += linelen;
 		}
-	} else {
+/*REM*/#endif
+	//*REM*/Dont know how to handle this for trans color
+		  } else {
 		MW_S32 psr, psg, psb;
 		MW_S32 psa, psa_inv;
 		MW_U32 pd;
@@ -438,10 +543,15 @@
 	int slinelen = srcpsd->linelen;
 	int dlinelen_minus_w4;
 	int slinelen_minus_w4;
+/*REM*/	int clinelen_minus_w;
+/*REM*/	int dlinelen_minus_w;
+/*REM*/	int slinelen_minus_w;
+/*REM*/	int alinelen_minus_w;
 #if ALPHABLEND
 	unsigned int alpha;
 #endif
 
+
 	assert(dst != 0);
 	assert(dstx >= 0 && dstx < dstpsd->xres);
 	assert(dsty >= 0 && dsty < dstpsd->yres);
@@ -456,6 +566,25 @@
 	assert(srcy + h <= srcpsd->yres);
 
 	DRAWON;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty)
+	/*REM*/   {
+	/*REM*/	   MWCOORD crcx=dstx-clipmap->clipregion->left;
+	/*REM*/	   MWCOORD crcy=dsty-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=dstx-gr_alpha_x;
+	/*REM*/MWCOORD rely=dsty-gr_alpha_y;
+	/*REM*/unsigned char* alphac=NULL;
+	/*REM*/if(gr_alpha&& (relx>=0)&&(relx+w<=gr_alpha_width)&&(rely>=0)&&(rely+h<=gr_alpha_height))
+	/*REM*/   alphac=&gr_alpha[relx+(rely*gr_alpha_width)];
+/*REM*/#endif
+
 	dst += dstx + dsty * dlinelen;
 	src += srcx + srcy * slinelen;
 
@@ -499,6 +628,7 @@
       stdblit:
 #endif
 
+
 	if (op == MWROP_COPY) {
 		/* copy from bottom up if dst in src rectangle */
 		/* memmove is used to handle x case */
@@ -514,6 +644,29 @@
 			dst += dlinelen;
 			src += slinelen;
 		}
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/	} else if ((op & MWROP_EXTENSION) == MWROP_SRCTRANSCOPY)
+/*REM*/	  {
+/*REM*/	    dlinelen_minus_w = (dlinelen - w);
+/*REM*/	    slinelen_minus_w = (slinelen - w);
+/*REM*/	    clinelen_minus_w = (clinelen - w);
+/*REM*/	    alinelen_minus_w = (gr_alpha_width - w);
+/*REM*/	    while (--h >= 0) {
+/*REM*/	       for (i = 0; i < w; ++i) {
+/*REM*/	        if((crc&&(*crc))||(!crc)) 
+/*REM*/		 {if((alphac&&(*alphac))||(!alphac)) *dst = *src;}
+/*REM*/	         src++;
+/*REM*/	         dst++;
+/*REM*/	         if(crc)crc++;
+/*REM*/	         if(alphac)alphac++;
+/*REM*/        }
+/*REM*/	       dst += dlinelen_minus_w;
+/*REM*/	       src += slinelen_minus_w;
+/*REM*/	       if(crc) crc += clinelen_minus_w;
+/*REM*/	       if(alphac) alphac += alinelen_minus_w;
+/*REM*/     }
+/*REM*/#endif
+
 	} else if (MWROP_TO_MODE(op) <= MWMODE_SIMPLE_MAX) {
 		for (i = 0; i < w; ++i) {
 			applyOp(MWROP_TO_MODE(op), *src, dst, ADDR32);
diff -urN microwindows-0.91/src/drivers/fblin8.c microwindows-0.91.g100/src/drivers/fblin8.c
--- microwindows-0.91/src/drivers/fblin8.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/drivers/fblin8.c	2007-06-09 13:33:31.000000000 +0200
@@ -19,6 +19,13 @@
 #include "device.h"
 #include "fb.h"
 
+/*REM*/extern unsigned char* gr_alpha;  /* current alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_x;         /* current x position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_y;         /* current y position of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_width;     /* current width of alpha channel*/
+/*REM*/extern MWCOORD    gr_alpha_height;    /* current height of alpha channel*/
+/*REM*/extern MWCLIPMAP *clipmap ;
+
 #if ALPHABLEND
 /*
  * Alpha lookup tables for 256 color palette systems
@@ -55,6 +62,23 @@
 	assert (x >= 0 && x < psd->xres);
 	assert (y >= 0 && y < psd->yres);
 	assert (c < psd->ncolors);
+#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty )
+	/*REM*/   {
+	/*REM*/	   MWCOORD crcx=x-clipmap->clipregion->left;
+	/*REM*/	   MWCOORD crcy=y-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/    if(!(*crc)) return;
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=x-gr_alpha_x;
+	/*REM*/MWCOORD rely=y-gr_alpha_y;
+	/*REM*/if(gr_alpha && (relx>=0)&&(relx<gr_alpha_width)&&(rely>=0)&&(rely<gr_alpha_height))
+	/*REM*/  {if(!gr_alpha[relx+(rely*gr_alpha_width)]) return;}
+#endif
 
 	DRAWON;
 	if(gr_mode == MWMODE_COPY)
@@ -90,8 +114,58 @@
 	assert (y >= 0 && y < psd->yres);
 	assert (c < psd->ncolors);
 
-	DRAWON;
 	addr += x1 + y * psd->linelen;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty )
+	/*REM*/   {
+	/*REM*/	    MWCOORD crcx=x1-clipmap->clipregion->left;
+	/*REM*/	    MWCOORD crcy=y-clipmap->clipregion->top;
+	/*REM*/     clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/     crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+	
+	/*REM*/ MWCOORD relx1=x1-gr_alpha_x;
+	/*REM*/ MWCOORD rely =y-gr_alpha_y;
+	/*REM*/ unsigned char* alpha=NULL;
+  	/*REM*/  if(gr_alpha && (relx1>=0) && (relx1<gr_alpha_width) && (rely>=0) && (rely<gr_alpha_height) &&
+	/*REM*/     ((x2-x1)<=gr_alpha_width))
+	/*REM*/       alpha=&gr_alpha[relx1+(rely*gr_alpha_width)];
+/*REM*/#endif
+
+	DRAWON;
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/if (gr_mode == MWMODE_COPY) {
+	/*REM*/  if(crc||alpha) {
+ 	/*REM*/      while (x1++ <= x2){
+	/*REM*/	       if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) *addr = c;}
+	/*REM*/	       if(crc)crc++;
+	/*REM*/	       if(alpha)alpha++;
+	/*REM*/	       addr++;
+	/*REM*/	     }
+	/*REM*/	 } else {
+	/*REM*/	      memset(addr, c, x2 - x1 + 1);
+	/*REM*/	 }
+	/*REM*/} else if (gr_mode <= MWMODE_SIMPLE_MAX) {
+	/*REM*/    if(crc||alpha) {
+	/*REM*/	     while (x1++ <= x2) {
+	/*REM*/	       if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) applyOp(gr_mode, c, addr, ADDR8);}
+	/*REM*/	       if(crc)crc++;
+	/*REM*/	       if(alpha)alpha++;
+	/*REM*/	       ++addr;
+	/*REM*/	     }
+	/*REM*/	   } else {
+	/*REM*/	     while(x1++ <= x2) {
+	/*REM*/	       applyOp(gr_mode, c, addr, ADDR8);
+	/*REM*/	       ++addr;
+	/*REM*/      }
+	/*REM*/    }
+	/*REM*/}
+/*REM*/#else
 	if(gr_mode == MWMODE_COPY)
 		memset(addr, c, x2 - x1 + 1);
 	else {
@@ -100,6 +174,7 @@
 			++addr;
 		}
 	}
+/*REM*/#endif
 	DRAWOFF;
 }
 
@@ -116,9 +191,48 @@
 	assert (y2 >= 0 && y2 < psd->yres);
 	assert (y2 >= y1);
 	assert (c < psd->ncolors);
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty )
+	/*REM*/   {
+	/*REM*/	    MWCOORD crcx=x-clipmap->clipregion->left;
+	/*REM*/	    MWCOORD crcy=y1-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=x-gr_alpha_x;
+	/*REM*/MWCOORD rely1=y1-gr_alpha_y;
+	/*REM*/MWCOORD rely2=y2-gr_alpha_y;
+	/*REM*/unsigned char* alpha=NULL;
+	/*REM*/if(gr_alpha&& (relx>=0)&&(relx<gr_alpha_width)&&(rely1>=0)&&(rely1+rely2<=gr_alpha_height))
+	/*REM*/     alpha=&gr_alpha[relx+(rely1*gr_alpha_width)];
+/*REM*/#endif
 
 	DRAWON;
 	addr += x + y1 * linelen;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/if (gr_mode == MWMODE_COPY) {
+	/*REM*/	while (y1++ <= y2) {
+	/*REM*/	        if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha)) *addr = c;}
+	/*REM*/	        if(crc)crc+=clinelen;
+	/*REM*/	        if(alpha)alpha+=gr_alpha_width;
+	/*REM*/		addr += linelen;
+	/*REM*/	}
+	/*REM*/} else if (gr_mode <= MWMODE_SIMPLE_MAX) {
+	/*REM*/	while (y1++ <= y2) {
+	/*REM*/         if((crc&&(*crc))||(!crc)) 
+	/*REM*/		 {if((alpha&&(*alpha))||(!alpha))applyOp(gr_mode, c, addr, ADDR8);}
+	/*REM*/         if(crc)crc+=clinelen;
+	/*REM*/	        if(alpha)alpha+=gr_alpha_width;
+	/*REM*/		addr += linelen;
+	/*REM*/ }
+	/*REM*/}
+/*REM*/#else
+
 	if(gr_mode == MWMODE_COPY) {
 		while(y1++ <= y2) {
 			*addr = c;
@@ -130,6 +244,8 @@
 			addr += linelen;
 		}
 	}
+/*REM*/#endif
+
 	DRAWOFF;
 }
 
@@ -140,8 +256,13 @@
 {
 	ADDR8	dst;
 	ADDR8	src;
+	int     i;
 	int	dlinelen = dstpsd->linelen;
 	int	slinelen = srcpsd->linelen;
+/*REM*/	int clinelen_minus_w;
+/*REM*/	int dlinelen_minus_w;
+/*REM*/	int slinelen_minus_w;
+/*REM*/	int alinelen_minus_w;
 #if ALPHABLEND
 	unsigned int srcalpha, dstalpha;
 #endif
@@ -160,7 +281,26 @@
 	assert (srcy+h <= srcpsd->yres);
 
 	DRAWON;
-	dst = ((ADDR8)dstpsd->addr) + dstx + dsty * dlinelen;
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*REM*/	int   clinelen=0;
+	/*REM*/	char *crc=NULL;
+	/*REM*/ if(clipmap && clipmap->dirty )
+	/*REM*/   {
+	/*REM*/	   MWCOORD crcx=dstx-clipmap->clipregion->left;
+	/*REM*/	   MWCOORD crcy=dsty-clipmap->clipregion->top;
+	/*REM*/    clinelen=clipmap->clipregion->right-clipmap->clipregion->left;
+	/*REM*/    crc=clipmap->clipmap + crcx + (crcy * clinelen);
+	/*REM*/   }
+
+	/*REM*/MWCOORD relx=dstx-gr_alpha_x;
+	/*REM*/MWCOORD rely=dsty-gr_alpha_y;
+	/*REM*/unsigned char* alphac=NULL;
+	/*REM*/if(gr_alpha&& (relx>=0)&&(relx+w<=gr_alpha_width)&&(rely>=0)&&(rely+h<=gr_alpha_height))
+	/*REM*/   alphac=&gr_alpha[relx+(rely*gr_alpha_width)];
+/*REM*/#endif
+
+ 	dst = ((ADDR8)dstpsd->addr) + dstx + dsty * dlinelen;
 	src = ((ADDR8)srcpsd->addr) + srcx + srcy * slinelen;
 
 #if ALPHABLEND
@@ -216,6 +356,29 @@
 			dst += dlinelen;
 			src += slinelen;
 		}
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/	} else if ((op & MWROP_EXTENSION) == MWROP_SRCTRANSCOPY)
+/*REM*/	  {
+/*REM*/	    dlinelen_minus_w = (dlinelen - w);
+/*REM*/	    slinelen_minus_w = (slinelen - w);
+/*REM*/	    clinelen_minus_w = (clinelen - w);
+/*REM*/	    alinelen_minus_w = (gr_alpha_width - w);
+/*REM*/	    while (--h >= 0) {
+/*REM*/	       for (i = 0; i < w; ++i) {
+/*REM*/	        if((crc&&(*crc))||(!crc)) 
+/*REM*/		 {if((alphac&&(*alphac))||(!alphac)) *dst = *src;}
+/*REM*/	         src++;
+/*REM*/	         dst++;
+/*REM*/	         if(crc)crc++;
+/*REM*/	         if(alphac)alphac++;
+/*REM*/        }
+/*REM*/	       dst += dlinelen_minus_w;
+/*REM*/	       src += slinelen_minus_w;
+/*REM*/	       if(crc) crc += clinelen_minus_w;
+/*REM*/	       if(alphac) alphac += alinelen_minus_w;
+/*REM*/     }
+/*REM*/#endif
+
 	} else {
 		while (--h >= 0) {
 			int i;
diff -urN microwindows-0.91/src/drivers/kbd_ttyscan.c microwindows-0.91.g100/src/drivers/kbd_ttyscan.c
--- microwindows-0.91/src/drivers/kbd_ttyscan.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/drivers/kbd_ttyscan.c	2006-10-12 18:23:44.000000000 +0200
@@ -18,7 +18,11 @@
 #include "device.h"
 #include "fb.h"
 
+/*REM*/#ifndef KEYBOARDDEV
 #define KEYBOARD	"/dev/tty"	/* console kbd to open*/
+/*REM*/#else
+#define KEYBOARD	KEYBOARDDEV
+/*REM*/#endif
 
 static int  TTY_Open(KBDDEVICE *pkd);
 static void TTY_Close(void);
diff -urN microwindows-0.91/src/drivers/Makefile.orig microwindows-0.91.g100/src/drivers/Makefile.orig
--- microwindows-0.91/src/drivers/Makefile.orig	1970-01-01 01:00:00.000000000 +0100
+++ microwindows-0.91.g100/src/drivers/Makefile.orig	2006-10-12 18:23:44.000000000 +0200
@@ -0,0 +1,26 @@
+##############################################################################
+# Microwindows template Makefile
+# Copyright (c) 2000 Martin Jolicoeur, Greg Haerr
+# Portions Copyright (c) 2002 by Koninklijke Philips Electronics N.V.
+##############################################################################
+
+ifndef MW_DIR_SRC
+MW_DIR_SRC := $(CURDIR)/..
+endif
+MW_DIR_RELATIVE := drivers/
+include $(MW_DIR_SRC)/Path.rules
+include $(CONFIG)
+
+############################# targets section ################################
+
+# If you want to create a library with the objects files, define the name here
+LIBNAME = libmwdrivers.a
+#LIBNAMESO = libmwdrivers.so
+
+OBJS := $(MW_DIR_OBJ)/drivers/obsolete.o
+
+######################### Makefile.rules section #############################
+
+include $(MW_DIR_SRC)/Makefile.rules
+
+######################## Tools targets section ###############################
diff -urN microwindows-0.91/src/drivers/mou_vrlinux.c microwindows-0.91.g100/src/drivers/mou_vrlinux.c
--- microwindows-0.91/src/drivers/mou_vrlinux.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/drivers/mou_vrlinux.c	2007-05-17 16:38:37.000000000 +0200
@@ -23,12 +23,20 @@
 
 #ifdef TOUCHSCREEN_HELIO
 #define TS_DEVICE "Helio"
+/*REM*/#ifndef MOUSEDEV
 #define TS_DEVICE_FILE "/dev/tpanel"
+/*REM*/#else 
+/*REM*/#define TS_DEVICE_FILE MOUSEDEV
+/*REM*/#endif
 #endif
 
 #ifdef TOUCHSCREEN_EPLANET
 #define TS_DEVICE "Embedded Planet"
+/*REM*/#ifndef MOUSEDEV
 #define TS_DEVICE_FILE "/dev/tpanel"
+/*REM*/#else 
+/*REM*/#define TS_DEVICE_FILE MOUSEDEV
+/*REM*/#endif
 #include <linux/tpanel.h>
 #endif
 
@@ -36,6 +44,8 @@
 #error "You didn't define a device for the VR-Linux touchscreen driver!"
 #endif
 
+/*REM*/ static int pd_fd = -1;
+
 static int PD_Open(MOUSEDEVICE *pmd)
 {	
 #ifdef TOUCHSCREEN_EPLANET
@@ -106,9 +116,9 @@
 #endif
 	int bytes_read;
 
-	bytes_read = read(pd_fd, &event, sizeof(event));
+	bytes_read = read(pd_fd, /*REM: bugfix*/ data, sizeof(/*REM: bugfix*/data));
 	
-	if(bytes_read != sizeof(event)) {
+	if(bytes_read != sizeof(/*REM: bugfix*/data)) {
 		if(bytes_read == -1) {
 			if(errno == EINTR || errno == EAGAIN) return 0;
 			EPRINTF("[%s] Error %d reading from touch panel\n", TS_DEVICE, errno);
@@ -116,7 +126,7 @@
 		}
 		
 		EPRINTF("[%s] Wrong number of bytes %d read from touch panel "
-			"(expected %d)\n", TS_DEVICE, bytes_read, sizeof(event));
+			"(expected %d)\n", TS_DEVICE, bytes_read, sizeof(/*REM: bugfix*/data));
 		return 0;
 	}
 	
@@ -153,6 +163,6 @@
 	PD_GetButtonInfo,
 	PD_GetDefaultAccel,
 	PD_Read,
-	NULL
+	NULL /*REM: bugfix*/,
 	MOUSE_TRANSFORM /* input filter flags */
 };
diff -urN microwindows-0.91/src/drivers/scr_x11.c microwindows-0.91.g100/src/drivers/scr_x11.c
--- microwindows-0.91/src/drivers/scr_x11.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/drivers/scr_x11.c	2006-10-12 18:23:44.000000000 +0200
@@ -921,6 +921,7 @@
 	/* draw savebits for readpixel or blit */
 	savebits.DrawPixel(&savebits, x, y, c);
 
+/*REM*/#ifndef TRANS_COLOR
 	if (gr_mode == MWMODE_COPY) {
 		set_color(c);
 		set_mode(gr_mode);
@@ -928,6 +929,10 @@
 	} else {
 		update_from_savebits(x, y, 1, 1);
 	}
+/*REM*/#else
+	update_from_savebits(x, y, 1, 1);
+/*REM*/#endif
+
 }
 
 static MWPIXELVAL
@@ -943,6 +948,7 @@
 	/* draw savebits for readpixel or blit */
 	savebits.DrawHorzLine(&savebits, x1, x2, y, c);
 
+/*REM*/#ifndef TRANS_COLOR
 	if (gr_mode == MWMODE_COPY) {
 		set_color(c);
 		set_mode(gr_mode);
@@ -952,6 +958,13 @@
 				     (x1 < x2 ? x2 - x1 + 1 : x1 - x2 + 1),
 				     1);
 	}
+/*REM*/#else
+	  update_from_savebits((x1 < x2 ? x1 : x2), y,
+			       (x1 < x2 ? x2 - x1 + 1 : x1 - x2 + 1),
+			       1);
+/*REM*/#endif
+
+
 }
 
 static void
@@ -959,6 +972,7 @@
 {
 	savebits.DrawVertLine(&savebits, x, y1, y2, c);
 
+/*REM*/#ifndef TRANS_COLOR
 	if (gr_mode == MWMODE_COPY) {
 		set_color(c);
 		set_mode(gr_mode);
@@ -968,6 +982,13 @@
 				     1,
 				     (y1 < y2 ? y2 - y1 + 1 : y1 - y2 + 1));
 	}
+
+/*REM*/#else
+	  update_from_savebits(x, (y1 < y2 ? y1 : y2),
+			       1,
+			       (y1 < y2 ? y2 - y1 + 1 : y1 - y2 + 1));
+/*REM*/#endif
+
 }
 
 static void
@@ -977,6 +998,7 @@
 	/* draw savebits for readpixel or blit */
 	savebits.FillRect(&savebits, x1, y1, x2, y2, c);
 
+/*REM*/#ifndef TRANS_COLOR
 	if (gr_mode == MWMODE_COPY) {
 		set_color(c);
 		set_mode(gr_mode);
@@ -985,6 +1007,9 @@
 	} else {
 		update_from_savebits(x1, y1, (x2-x1)+1, (y2-y1)+1);
 	}
+/*REM*/#else
+		update_from_savebits(x1, y1, (x2-x1)+1, (y2-y1)+1);
+/*REM*/#endif
 }
 
 static void
diff -urN microwindows-0.91/src/engine/devclip2.c microwindows-0.91.g100/src/engine/devclip2.c
--- microwindows-0.91/src/engine/devclip2.c	2007-06-17 21:56:36.000000000 +0200
+++ microwindows-0.91.g100/src/engine/devclip2.c	2007-06-16 17:57:08.000000000 +0200
@@ -8,6 +8,7 @@
  */
 #include <stdio.h>
 #include "device.h"
+/*REM*/#include <string.h>
 
 /* Clip cache rectangle information.
  * After calling GdClipPoint, this rectangle is guaranteed to contain the
@@ -20,7 +21,151 @@
 MWCOORD clipmaxy;		/* maximum y value of cache rectangle */
 
 static MWBOOL	clipresult;	/* whether clip rectangle is plottable */
-MWCLIPREGION *clipregion = NULL;
+MWCLIPREGION *clipregion = NULL; 
+/*REM*/MWCLIPMAP *clipmap     = NULL; /*current clipmap*/
+/*REM*/MWCLIPMAP *clipmapSave = NULL; /*current saved clipmap*/
+
+//*REM*/BEGIN
+/**
+ * Set a clip map for future drawing actions.
+ * Each pixel will be drawn by the screendriver only if the corresponding 
+ * byte in clipm is set to 0xff. clipm must always
+ * be as big as the current clipping region.
+ * 
+ *
+ * @param clipm pointer to the clipmap
+ * 
+ */
+void
+GdSetClipMap(MWCLIPMAP *clipm)
+{
+  if (clipmap==clipm)
+    return;
+
+  if(clipmap) GdDestroyClipMap(clipmap);
+  clipmap=clipm;
+}
+
+/**
+ * Save the current clipmap and hide
+ * it for future calls. Use GdRestoreClipMap
+ * to make it visible again. Already saved 
+ * clipmaps are deleted.
+ */
+void
+GdSaveClipMap()
+{
+  if(clipmapSave) GdDestroyClipMap(clipmapSave);
+  clipmapSave=clipmap;
+  clipmap=NULL;
+}
+
+/**
+ * Restore saved clipmap. Current 
+ * clipmap will be deleted if set.
+ * 
+ */
+void
+GdRestoreClipMap()
+{
+  if(clipmap) GdDestroyClipMap(clipmap);
+  clipmap=clipmapSave;
+  clipmapSave=NULL;
+}
+
+/**
+ * Destroys clipmap.
+ * 
+ *
+ * @param clipmap Clipmap to destroy
+ * 
+ */
+void GdDestroyClipMap(MWCLIPMAP *clipmap)
+{
+  if(clipmap)
+    {
+      if(clipmap->clipregion)
+	free(clipmap->clipregion);
+      if(clipmap->clipmap)
+	free(clipmap->clipmap);
+      free(clipmap);
+    }
+}
+
+/**
+ * Allocates clipmap and fills it with initval.
+ * 
+ *
+ * @param minx Left x position relative to rootwp.
+ * @param miny Top y position relative to rootwp.
+ * @param maxx Right x position relative to rootwp.
+ * @param maxy Bottom y position relative to rootwp.
+ * @param initval Initial value for clipmap. 
+ * @return pointer to new clipmap
+ * 
+ */
+MWCLIPMAP *GdAllocClipMap(MWCOORD minx,MWCOORD miny,MWCOORD maxx,MWCOORD maxy,unsigned char initval)
+{
+  //alloc MWCLIPMAP
+  MWCLIPMAP *clipmap=calloc(sizeof(MWCLIPMAP), 1);
+  if (clipmap == NULL) {
+    //GsError(GR_ERROR_MALLOC_FAILED, 0);
+    return NULL;
+  }
+  memset(clipmap,0x0,sizeof(MWCLIPMAP));
+
+  //alloc MWRECT
+  clipmap->clipregion=calloc(sizeof(MWRECT),1);
+  if (clipmap->clipregion == NULL) {
+    free(clipmap);
+    //GsError(GR_ERROR_MALLOC_FAILED, 0);
+    return NULL;
+  }
+
+  clipmap->clipregion->left  =minx;
+  clipmap->clipregion->top   =miny;
+  clipmap->clipregion->right =maxx;
+  clipmap->clipregion->bottom=maxy;
+
+  //alloc char
+  clipmap->clipmap=calloc((maxy-miny)*(maxx-minx),1);
+  if (clipmap->clipmap == NULL) {
+    free(clipmap->clipregion);
+    free(clipmap);
+    //GsError(GR_ERROR_MALLOC_FAILED, 0);
+    return NULL;
+  }
+  memset(clipmap->clipmap,initval,(maxy-miny)*(maxx-minx));
+  return clipmap;
+}
+
+/**
+ * Returns current clipmap.
+ * 
+ *
+ * @return Pointer to current clipmap.
+ * 
+ */
+MWCLIPMAP *GdGetClipMap()
+{
+  return clipmap;
+}
+
+/**
+ * Returns current clip region.
+ * 
+ *
+ * @return Pointer to current clip region.
+ * 
+ */
+MWCLIPREGION *GdGetClipRegion()
+{
+  return clipregion;
+}
+
+//*REM*/END
+
+
 
 /**
  * Set a clip region for future drawing actions.
@@ -35,13 +180,15 @@
 void
 GdSetClipRegion(PSD psd, MWCLIPREGION *reg)
 {
-  if(clipregion)
-  	GdDestroyRegion(clipregion);
-
-  if(!reg)
-	  reg = GdAllocRegion();
+  /*REM*/ if(clipregion!=reg)
+  /*REM*/   {
+               if(clipregion)
+  	         GdDestroyRegion(clipregion);
+               if(!reg)
+	          reg = GdAllocRegion();
 
-  clipregion = reg;
+               clipregion = reg;
+  /*REM*/ }
 
 
 #if 0
